# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_prism_py_client.models.common.v1.config.IpRange import IpRange  # noqa: F401,E501

class BaseNetwork(object):

    """This model would abstract away the common attributes as part of internal and external networks.

    :param default_gateway: (:attr:`default_gateway`) 
    :type default_gateway: required
    
    
    :param subnet_mask: (:attr:`subnet_mask`) 
    :type subnet_mask: required
    
    
    :param ip_ranges: (:attr:`ip_ranges`) Range of IPs used for Prism Central network setup.
    :type ip_ranges: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'default_gateway': 'common.v1.config.IPAddressOrFQDN',
        'subnet_mask': 'common.v1.config.IPAddressOrFQDN',
        'ip_ranges': 'list[common.v1.config.IpRange]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'default_gateway': 'defaultGateway',
        'subnet_mask': 'subnetMask',
        'ip_ranges': 'ipRanges',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, default_gateway=None, subnet_mask=None, ip_ranges=None, *args, **kwargs):  # noqa: E501
        self.__default_gateway = None
        self.__subnet_mask = None
        self.__ip_ranges = None
        self.discriminator = None
        self.__default_gateway = default_gateway
        self.__subnet_mask = subnet_mask
        self.__ip_ranges = ip_ranges
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'prism.v4.config.BaseNetwork'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def default_gateway(self):
        """
        

        :type:
            :class:`~ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__default_gateway

    @default_gateway.setter
    def default_gateway(self, default_gateway):
        if default_gateway is None:
            raise ValueError("Invalid value for `default_gateway`, must not be `None`")  # noqa: E501

        self.__default_gateway = default_gateway

    @property
    def subnet_mask(self):
        """
        

        :type:
            :class:`~ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__subnet_mask

    @subnet_mask.setter
    def subnet_mask(self, subnet_mask):
        if subnet_mask is None:
            raise ValueError("Invalid value for `subnet_mask`, must not be `None`")  # noqa: E501

        self.__subnet_mask = subnet_mask

    @property
    def ip_ranges(self):
        """
        Range of IPs used for Prism Central network setup.

        :type:
             list[ :class:`~ntnx_prism_py_client.models.common.v1.config.IpRange` ]
        """  # noqa: E501
        return self.__ip_ranges

    @ip_ranges.setter
    def ip_ranges(self, ip_ranges):
        if ip_ranges is None:
            raise ValueError("Invalid value for `ip_ranges`, must not be `None`")  # noqa: E501

        self.__ip_ranges = ip_ranges

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(BaseNetwork, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BaseNetwork):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

