# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_prism_py_client.models.clustermgmt.v4.config.ClusterNetwork import ClusterNetwork  # noqa: F401,E501
from ntnx_prism_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_prism_py_client.models.prism.v4.config.BaseNetwork import BaseNetwork  # noqa: F401,E501
from ntnx_prism_py_client.models.prism.v4.config.ExternalNetwork import ExternalNetwork  # noqa: F401,E501
from ntnx_prism_py_client.models.prism.v4.config.NetworkCapability import NetworkCapability  # noqa: F401,E501

class DomainManagerNetwork(ClusterNetwork):

    """Domain manager (Prism Central) network configuration details.

    :param internal_networks: (:attr:`internal_networks`) This configuration is used to internally manage Prism Central network.
    :type internal_networks: 
    
    
    :param external_networks: (:attr:`external_networks`) This configuration is used to manage Prism Central.
    :type external_networks: 
    
    
    :param capability: (:attr:`capability`) 
    :type capability: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'internal_networks': 'list[prism.v4.config.BaseNetwork]',
        'external_networks': 'list[prism.v4.config.ExternalNetwork]',
        'capability': 'prism.v4.config.NetworkCapability',
        'external_address': 'common.v1.config.IPAddress',
        'name_servers': 'list[common.v1.config.IPAddressOrFQDN]',
        'ntp_servers': 'list[common.v1.config.IPAddressOrFQDN]',
        'fqdn': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'internal_networks': 'internalNetworks',
        'external_networks': 'externalNetworks',
        'capability': 'capability',
        'external_address': 'externalAddress',
        'name_servers': 'nameServers',
        'ntp_servers': 'ntpServers',
        'fqdn': 'fqdn',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, internal_networks=None, external_networks=None, capability=None, external_address=None, name_servers=None, ntp_servers=None, fqdn=None, *args, **kwargs):  # noqa: E501
        ClusterNetwork.__init__(self, external_address, name_servers, ntp_servers, fqdn, *args, **kwargs)
        self.__internal_networks = None
        self.__external_networks = None
        self.__capability = None
        self.discriminator = None
        if internal_networks is not None:
            self.__internal_networks = internal_networks
        if external_networks is not None:
            self.__external_networks = external_networks
        if capability is not None:
            self.__capability = capability

    def _initialize_object_type(self):
        return 'prism.v4.config.DomainManagerNetwork'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def internal_networks(self):
        """
        This configuration is used to internally manage Prism Central network.

        :type:
             list[ :class:`~ntnx_prism_py_client.models.prism.v4.config.BaseNetwork` ]
        """  # noqa: E501
        return self.__internal_networks

    @internal_networks.setter
    def internal_networks(self, internal_networks):

        self.__internal_networks = internal_networks

    @property
    def external_networks(self):
        """
        This configuration is used to manage Prism Central.

        :type:
             list[ :class:`~ntnx_prism_py_client.models.prism.v4.config.ExternalNetwork` ]
        """  # noqa: E501
        return self.__external_networks

    @external_networks.setter
    def external_networks(self, external_networks):

        self.__external_networks = external_networks

    @property
    def capability(self):
        """
        

        :type:
            :class:`~ntnx_prism_py_client.models.prism.v4.config.NetworkCapability`
        """  # noqa: E501
        return self.__capability

    @capability.setter
    def capability(self, capability):

        self.__capability = capability

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DomainManagerNetwork, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DomainManagerNetwork):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

