# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class DomainManagerResourceConfig(object):

    """This configuration is used to provide the resource-related details like container external identifiers, number of VCPUs, memory size, data disk size of the domain manager (Prism Central). In the case of a multi-node setup, the sum of resources like number of VCPUs, memory size and data disk size are provided.

    :param num_vcpus: (:attr:`num_vcpus`) This property is used for readOnly purposes to display Prism Central number of VCPUs allocation.
    :type num_vcpus: 
    
    
    :param memory_size_bytes: (:attr:`memory_size_bytes`) This property is used for readOnly purposes to display Prism Central RAM allocation at the cluster level.
    :type memory_size_bytes: 
    
    
    :param data_disk_size_bytes: (:attr:`data_disk_size_bytes`) This property is used for readOnly purposes to display Prism Central data disk size allocation at a cluster level.
    :type data_disk_size_bytes: 
    
    
    :param container_ext_ids: (:attr:`container_ext_ids`) The external identifier of the container that will be used to create the domain manager (Prism Central) cluster.
    :type container_ext_ids: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'num_vcpus': 'int',
        'memory_size_bytes': 'int',
        'data_disk_size_bytes': 'int',
        'container_ext_ids': 'list[str]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'num_vcpus': 'numVcpus',
        'memory_size_bytes': 'memorySizeBytes',
        'data_disk_size_bytes': 'dataDiskSizeBytes',
        'container_ext_ids': 'containerExtIds',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, num_vcpus=None, memory_size_bytes=None, data_disk_size_bytes=None, container_ext_ids=None, *args, **kwargs):  # noqa: E501
        self.__num_vcpus = None
        self.__memory_size_bytes = None
        self.__data_disk_size_bytes = None
        self.__container_ext_ids = None
        self.discriminator = None
        if num_vcpus is not None:
            self.__num_vcpus = num_vcpus
        if memory_size_bytes is not None:
            self.__memory_size_bytes = memory_size_bytes
        if data_disk_size_bytes is not None:
            self.__data_disk_size_bytes = data_disk_size_bytes
        if container_ext_ids is not None:
            self.__container_ext_ids = container_ext_ids
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'prism.v4.config.DomainManagerResourceConfig'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def num_vcpus(self):
        """
        This property is used for readOnly purposes to display Prism Central number of VCPUs allocation.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_vcpus

    @num_vcpus.setter
    def num_vcpus(self, num_vcpus):

        self.__num_vcpus = num_vcpus

    @property
    def memory_size_bytes(self):
        """
        This property is used for readOnly purposes to display Prism Central RAM allocation at the cluster level.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__memory_size_bytes

    @memory_size_bytes.setter
    def memory_size_bytes(self, memory_size_bytes):

        self.__memory_size_bytes = memory_size_bytes

    @property
    def data_disk_size_bytes(self):
        """
        This property is used for readOnly purposes to display Prism Central data disk size allocation at a cluster level.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__data_disk_size_bytes

    @data_disk_size_bytes.setter
    def data_disk_size_bytes(self, data_disk_size_bytes):

        self.__data_disk_size_bytes = data_disk_size_bytes

    @property
    def container_ext_ids(self):
        """
        The external identifier of the container that will be used to create the domain manager (Prism Central) cluster.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__container_ext_ids

    @container_ext_ids.setter
    def container_ext_ids(self, container_ext_ids):

        self.__container_ext_ids = container_ext_ids

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DomainManagerResourceConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DomainManagerResourceConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

