# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501

class ConnectionConfig(object):

    """Connection configuration to be used when making a connection with the object store. 

    :param ip_address_or_hostname: (:attr:`ip_address_or_hostname`) 
    :type ip_address_or_hostname: required
    
    
    :param should_skip_certificate_validation: (:attr:`should_skip_certificate_validation`) Skips the verification of the certificate during communication with the object store endpoint.  (**Default** False)
    :type should_skip_certificate_validation: 
    
    
    :param certificate: (:attr:`certificate`) Certificate which will be used while validating the object store identity. 
    :type certificate: 
     max=42667 chars
    
    :param has_custom_certificate: (:attr:`has_custom_certificate`) Indicates whether a custom certificate were configured or not.
    :type has_custom_certificate: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'ip_address_or_hostname': 'common.v1.config.IPAddressOrFQDN',
        'should_skip_certificate_validation': 'bool',
        'certificate': 'str',
        'has_custom_certificate': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ip_address_or_hostname': 'ipAddressOrHostname',
        'should_skip_certificate_validation': 'shouldSkipCertificateValidation',
        'certificate': 'certificate',
        'has_custom_certificate': 'hasCustomCertificate',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ip_address_or_hostname=None, should_skip_certificate_validation=False, certificate=None, has_custom_certificate=None, *args, **kwargs):  # noqa: E501
        self.__ip_address_or_hostname = None
        self.__should_skip_certificate_validation = None
        self.__certificate = None
        self.__has_custom_certificate = None
        self.discriminator = None
        self.__ip_address_or_hostname = ip_address_or_hostname
        if should_skip_certificate_validation is not None:
            self.__should_skip_certificate_validation = should_skip_certificate_validation
        if certificate is not None:
            self.__certificate = certificate
        if has_custom_certificate is not None:
            self.__has_custom_certificate = has_custom_certificate
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'prism.v4.management.ConnectionConfig'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ip_address_or_hostname(self):
        """
        

        :type:
            :class:`~ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__ip_address_or_hostname

    @ip_address_or_hostname.setter
    def ip_address_or_hostname(self, ip_address_or_hostname):
        if ip_address_or_hostname is None:
            raise ValueError("Invalid value for `ip_address_or_hostname`, must not be `None`")  # noqa: E501

        self.__ip_address_or_hostname = ip_address_or_hostname

    @property
    def should_skip_certificate_validation(self):
        """
        Skips the verification of the certificate during communication with the object store endpoint. 

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__should_skip_certificate_validation

    @should_skip_certificate_validation.setter
    def should_skip_certificate_validation(self, should_skip_certificate_validation):

        self.__should_skip_certificate_validation = should_skip_certificate_validation

    @property
    def certificate(self):
        """
        Certificate which will be used while validating the object store identity. 

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__certificate

    @certificate.setter
    def certificate(self, certificate):
        if certificate is not None and len(certificate) > 42667:
            raise ValueError("Invalid value for `certificate`, length must be less than or equal to `42667`")  # noqa: E501

        self.__certificate = certificate

    @property
    def has_custom_certificate(self):
        """
        Indicates whether a custom certificate were configured or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__has_custom_certificate

    @has_custom_certificate.setter
    def has_custom_certificate(self, has_custom_certificate):

        self.__has_custom_certificate = has_custom_certificate

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ConnectionConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConnectionConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

