# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_prism_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_prism_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class RemoteCluster(ExternalizableAbstractModel):

    """This includes the attributes of a remote cluster, such as the cluster name, cluster type, and address details. The address details comprise the external address (either a virtual IP or FQDN), the port for incoming connections, and the internal addresses (node IP addresses).

    :param name: (:attr:`name`) Cluster name of a remote cluster.
    :type name: 
     min=1 chars, max=80 chars
    
    :param external_address: (:attr:`external_address`) 
    :type external_address: required
    
    
    :param node_ip_addresses: (:attr:`node_ip_addresses`) Node IP addresses of a registered cluster.
    :type node_ip_addresses: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'external_address': 'common.v1.config.IPAddressOrFQDN',
        'node_ip_addresses': 'list[common.v1.config.IPAddressOrFQDN]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'external_address': 'externalAddress',
        'node_ip_addresses': 'nodeIpAddresses',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, external_address=None, node_ip_addresses=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__external_address = None
        self.__node_ip_addresses = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        self.__external_address = external_address
        if node_ip_addresses is not None:
            self.__node_ip_addresses = node_ip_addresses

    def _initialize_object_type(self):
        return 'prism.v4.management.RemoteCluster'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def name(self):
        """
        Cluster name of a remote cluster.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 80:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `80`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def external_address(self):
        """
        

        :type:
            :class:`~ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__external_address

    @external_address.setter
    def external_address(self, external_address):
        if external_address is None:
            raise ValueError("Invalid value for `external_address`, must not be `None`")  # noqa: E501

        self.__external_address = external_address

    @property
    def node_ip_addresses(self):
        """
        Node IP addresses of a registered cluster.

        :type:
             list[ :class:`~ntnx_prism_py_client.models.common.v1.config.IPAddressOrFQDN` ]
        """  # noqa: E501
        return self.__node_ip_addresses

    @node_ip_addresses.setter
    def node_ip_addresses(self, node_ip_addresses):

        self.__node_ip_addresses = node_ip_addresses

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RemoteCluster, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RemoteCluster):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

