# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class EligibleCluster(object):

    """Eligible cluster object for PC backup. Containing some basic properties like cluster_uuid, cluster_name, remainingStorage, totalStorage 

    :param cluster_uuid: (:attr:`cluster_uuid`) Uuid of the eligible PE(cluster). 
    :type cluster_uuid: 
    
    
    :param cluster_name: (:attr:`cluster_name`) Name of the eligible PE(cluster). 
    :type cluster_name: 
    
    
    :param is_hosting_pe: (:attr:`is_hosting_pe`) Whether the candidate PE was hosting PC. 
    :type is_hosting_pe: 
    
    
    :param backed_up_entities_count_supported: (:attr:`backed_up_entities_count_supported`) The amount of entities which can be backed up to the PE from PC. 
    :type backed_up_entities_count_supported: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_uuid': 'str',
        'cluster_name': 'str',
        'is_hosting_pe': 'bool',
        'backed_up_entities_count_supported': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_uuid': 'clusterUuid',
        'cluster_name': 'clusterName',
        'is_hosting_pe': 'isHostingPe',
        'backed_up_entities_count_supported': 'backedUpEntitiesCountSupported',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_uuid=None, cluster_name=None, is_hosting_pe=None, backed_up_entities_count_supported=None, *args, **kwargs):  # noqa: E501
        self.__cluster_uuid = None
        self.__cluster_name = None
        self.__is_hosting_pe = None
        self.__backed_up_entities_count_supported = None
        self.discriminator = None
        if cluster_uuid is not None:
            self.__cluster_uuid = cluster_uuid
        if cluster_name is not None:
            self.__cluster_name = cluster_name
        if is_hosting_pe is not None:
            self.__is_hosting_pe = is_hosting_pe
        if backed_up_entities_count_supported is not None:
            self.__backed_up_entities_count_supported = backed_up_entities_count_supported
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'prism.v4.protectpc.EligibleCluster'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def cluster_uuid(self):
        """
        Uuid of the eligible PE(cluster). 

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_uuid

    @cluster_uuid.setter
    def cluster_uuid(self, cluster_uuid):
        if cluster_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_uuid = cluster_uuid

    @property
    def cluster_name(self):
        """
        Name of the eligible PE(cluster). 

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_name

    @cluster_name.setter
    def cluster_name(self, cluster_name):

        self.__cluster_name = cluster_name

    @property
    def is_hosting_pe(self):
        """
        Whether the candidate PE was hosting PC. 

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_hosting_pe

    @is_hosting_pe.setter
    def is_hosting_pe(self, is_hosting_pe):

        self.__is_hosting_pe = is_hosting_pe

    @property
    def backed_up_entities_count_supported(self):
        """
        The amount of entities which can be backed up to the PE from PC. 

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__backed_up_entities_count_supported

    @backed_up_entities_count_supported.setter
    def backed_up_entities_count_supported(self, backed_up_entities_count_supported):

        self.__backed_up_entities_count_supported = backed_up_entities_count_supported

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(EligibleCluster, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EligibleCluster):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

