# coding: utf-8


"""
IGNORE:
    Nutanix Prism APIs

    Manage Tasks, Category Associations and Submit Batch Operations.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class RecoveryStatus(object):

    """An object containing Recovery state and overall completion percentage of recovery task. 

    :param recovery_state: (:attr:`recovery_state`) Recovery state of recovery task. Possible values could be IDFDataRestore, WaitForProcessesToReconcile. 
    :type recovery_state: 
    
    
    :param recovery_state_title: (:attr:`recovery_state_title`) Recovery state title, the message that appears to the user. 
    :type recovery_state_title: 
    
    
    :param overall_completion_percentage: (:attr:`overall_completion_percentage`) Overall completion percentage of task. 
    :type overall_completion_percentage: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'recovery_state': 'str',
        'recovery_state_title': 'str',
        'overall_completion_percentage': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'recovery_state': 'recoveryState',
        'recovery_state_title': 'recoveryStateTitle',
        'overall_completion_percentage': 'overallCompletionPercentage',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, recovery_state=None, recovery_state_title=None, overall_completion_percentage=None, *args, **kwargs):  # noqa: E501
        self.__recovery_state = None
        self.__recovery_state_title = None
        self.__overall_completion_percentage = None
        self.discriminator = None
        if recovery_state is not None:
            self.__recovery_state = recovery_state
        if recovery_state_title is not None:
            self.__recovery_state_title = recovery_state_title
        if overall_completion_percentage is not None:
            self.__overall_completion_percentage = overall_completion_percentage
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'prism.v4.protectpc.RecoveryStatus'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def recovery_state(self):
        """
        Recovery state of recovery task. Possible values could be IDFDataRestore, WaitForProcessesToReconcile. 

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__recovery_state

    @recovery_state.setter
    def recovery_state(self, recovery_state):

        self.__recovery_state = recovery_state

    @property
    def recovery_state_title(self):
        """
        Recovery state title, the message that appears to the user. 

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__recovery_state_title

    @recovery_state_title.setter
    def recovery_state_title(self, recovery_state_title):

        self.__recovery_state_title = recovery_state_title

    @property
    def overall_completion_percentage(self):
        """
        Overall completion percentage of task. 

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__overall_completion_percentage

    @overall_completion_percentage.setter
    def overall_completion_percentage(self, overall_completion_percentage):

        self.__overall_completion_percentage = overall_completion_percentage

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RecoveryStatus, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RecoveryStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

